{$V-,X+}

Program EditLine;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    EditLine

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Demonstrates the use of RADU's DorLineEdit procedure.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU;

Var
  EntryCount  : Byte;

  Entrys      : Array[1..5] of String[40];
  Legals      : Array[1..5] of CharSet;
  Lens        : Array[1..5] of Byte;
  Key         : Char;

Begin { EditLine }
  DorInit;                                        { Initialise the Door Unit }

  {
    This program uses the up and down arrow keys. Therefore we must relocate
    the functions of these keys (increase and decrease time by one minute)
    to other keys.
  }

  DorExtKeys[ExtKey_CtrlPgUp]:=DorExtKeys[ExtKey_Up];{Move up-arrow to ^PgUp }
  DorExtKeys[ExtKey_CtrlPgDn]:=DorExtKeys[ExtKey_Down]; { Move down to ^PgDn }
  DorExtKeys[ExtKey_Up]:=DorNullProc;                       { Clear up-arrow }
  DorExtKeys[ExtKey_Down]:=DorNullProc;                   { Clear down-arrow }

  DorStatLn[9,1]:='ALT: [C]hat [G]arbage [H]angup [L]ockOut [N]extOn '+
                  '[O]verride [Q]uit to BBS';
  DorStatLn[9,2]:='     [S]ecurity  [^PgUp]-Inc Time  [^PgDn]-Dec Time  '+
                  '[F1]-[F8]=Extra Stats';

  If not (DorAnsi or DorAvatar) then
  Begin
    WriteLn ('Sorry, this example program requires ANSI or AVATAR codes..');
    WriteLn;
    WriteLn (RalGet(ralRtnCont),^A);
    Halt;
  End;  { If }

  DorDisplay ('EditLine','',False);     { Show screen, no hotkeys, no -more- }

  Entrys[1]:=ExitInfo.UserInfo.Name;                                  { Name }
  Entrys[2]:='';                                                   { Address }
  Entrys[3]:=ExitInfo.UserInfo.Location;                       { City, state }
  Entrys[4]:=ExitInfo.UserInfo.VoicePhone;                    { Home phone # }
  Entrys[5]:=ExitInfo.UserInfo.DataPhone;                     { Data phone # }

  Legals[1]:=[#32..#255];                           { Setup legal characters }
  Legals[2]:=Legals[1];
  Legals[3]:=Legals[2];
  Legals[4]:=['0'..'9','-','+'];
  Legals[5]:=Legals[4];

  Lens[1]:=40;                                        { Setup string lengths }
  Lens[2]:=40;
  Lens[3]:=40;
  Lens[4]:=15;
  Lens[5]:=15;

  For EntryCount:=1 to 5 do
  Begin
    GotoXY (24,EntryCount+5);
    Write (Entrys[EntryCount]);
  End;  { For }

  EntryCount:=1;

  Repeat
    GotoXY (24,EntryCount+5);
    Key:=DorLineEdit(Entrys[EntryCount],Lens[EntryCount],Legals[EntryCount],
                     [#1,#2,#13,#27],'_');
    Case Key of
      #1 :  Begin                                         { Up-Arrow pressed }
              If EntryCount>1 then
                Dec(EntryCount);
            End;  { UpArrow }
      #2 :  Begin                                       { Down-Arrow pressed }
              If EntryCount<5 then
                Inc(EntryCount);
            End;  { DownArrow }
      #13 : Begin                                            { Enter pressed }
              Inc (EntryCount);
              If EntryCount=6 then
                EntryCount:=1;
            End;  { Enter }
    End;  { Case }
  Until Key=#27;
End.  { EditLine }
