(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

                                         
                                           
                                           
                                         
                                        
                                           
                                         

                      Remote   Access   Door   Unit   v3.10

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

{$IFNDEF irastr}
Unit RaStruct;

(*
** Note : Dates defined with a LongInt are in dos packed-date format which
**        can be packed and unpacked using PACKTIME and UNPACKTIME (from the
**        DOS unit)
*)

interface
{$endif}

type
  AskType        = (Yes, No, Ask, Only);
  VideoType      = (Auto, Short, Long);
  MsgType        = (LocalMail, NetMail, EchoMail, InterNet, NewsGroup);
  MsgKindsType   = (Both, Private, Public, ROnly, NoReply);
  ResetType      = (Never, Week, Month, Year);
  OrphanType     = (Ignore, Create, Kill);
  FlagType       = array[1..4] of Byte;
  String80       = String[80];
  String15       = String[15];
  Time           = String[5];
  Date           = String[8];
  LongDate       = String[9];
  ByteArray32    = Array[1..32] of Byte;

  NodeIdxRecord  = Record                                      { NODEIDX.RA }
                     NodeType   : Byte;                            { 0=Zone }
                                                                 { 1=Region }
                                                                   { 2=Host }
                     Number     : Word;          { Zone, region, net number }
                     Cost       : Word;                      { # of credits }
                     IncEntry   : Byte;            { Entry#+1 in NODEINC.RA }
                     Pointer    : LongInt;            { Pointer to nodelist }
                   End;  { NodeIdxRecord }

  NodeIncRecord  = String[16];                                 { NODEINC.RA }
                                                            { Nodelist name }

  NetAddress  = Record
                  Zone   : Word;                                     { Zone }
                  Net    : Word;                                      { Net }
                  Node   : Word;                                     { Node }
                  Point  : Word;                                    { Point }
                End;  { NetAddress }

  LIMITSrecord   = record
                     Security,                        { Security to apply to }
                     Ltime,                                     { Time limit }
                     L300,                          { Download limit 300 bps }
                     L1200,                        { Download limit 1200 bps }
                     L2400,                        { Download limit 2400 bps }
                     L4800,                        { Download limit 4800 bps }
                     L7200,                        { Download limit 7200 bps }
                     L9600,                        { Download limit 9600 bps }
                     L12000,                      { Download limit 12000 bps }
                     L14400,                      { Download limit 14400 bps }
                     L16800,                      { Download limit 16800 bps }
                     L19200,                      { Download limit 19200 bps }
                     L38400,                      { Download limit 38400 bps }
                     Llocal,                    { Download limit local calls }
                     RatioNum,                       { Ratio number of files }
                     RatioK         : Word;                 { Kilobyte ratio }
                     PerMinCost     : Real;                { Per minute cost }
                     L21600,                      { Download limit 21600 bps }
                     L24000,                      { Download limit 24000 bps }
                     L26400,                      { Download limit 26400 bps }
                     L28800,                      { Download limit 28800 bps }
                     L57600,                      { Download limit 57600 bps }
                     L64000         : Word;       { Download limit 64000 bps }
                     FlexiTime      : Real;
                     LsessionTime   : Word;
                     ResetAmt       : Word;
                     ResetPeriod    : ResetType;
                     ResetOffset    : Word;

                     L31200,                      { Download limit 31200 bps }
                     L33600         : Word;       { Download limit 33600 bps }
                     FreeSpace      : Array[1..13] of Byte;
                   end; { Limitsrecord }

  LANGUAGErecord = record
                     Name           : String[20];            { Language name }
                     Attribute      : Byte;                      { Attribute }
                     DefName,                                { .RAL filename }
                     MenuPath,                               { Path to *.MNU }
                     TextPath,                                { Path to *.A* }
                     QuesPath       : String[60];            { Path to *.Q-A }
                     Security       : Word;                { Security needed }
                     Flags,                                   { Flags needed }
                     NotFlagsMask   : FlagType;            { Forbidden flags }
                     FreeSpace      : Array[1..190] of Byte;
                   end; { Languagerecord }

  LastReadRecord = Array[1..200] of Word;                    { LASTREAD.BBS }

  MsgInfoRecord = Record                                      { MSGINFO.BBS }
                    LowMsg       : Word;           { Lowest msg# in msgbase }
                    HighMsg      : Word;          { Highest msg# in msgbase }
                    TotalMsgs    : Word;                  { Total # of msgs }
                    TotalOnBoard : Array[1..200] of Word; { # of msgs/board }
                  End;  { MsgInfoRecord }

  MsgIdxRecord = Record                                        { MSGIDX.BBS }
                   MsgNum : Integer;                       { Message number }
                   Board  : Byte;          { Board # where MsgNum is stored }
                 End;  { MsgIdxRecord }

  MsgToIdxRecord = String[35];                               { MSGTOIDX.BBS }
                                             { Contains TO field of message }

  MsgHdrRecord = Record                                        { MSGHDR.BBS }
                   MsgNum     : Integer;                   { Message number }
                   PrevReply  : Word;      { Msg # of prev reply, 0 if none }
                   NextReply  : Word;      { Msg # of next reply, 0 if none }
                   TimesRead  : Word;            { Not used, times msg read }
                   StartBlock : Word;       { Record # in MSGTXT.BBS of msg }
                   NumBlocks  : Word;          { # of Records in MSGTXT.BBS }
                   DestNet    : Word;                { Net # of destination }
                   DestNode   : Word;                      { Node # of dest }
                   OrigNet    : Word;                     { Net # of origin }
                   OrigNode   : Word;                    { Node # of origin }
                   DestZone   : Byte;                      { Zone # of dest }
                   OrigZone   : Byte;                    { Zone # of origin }
                   Cost       : Word;           { Cost of message (NetMail) }
                   MsgAttr    : Byte;                  { Message attributes }
                                                           { Bit 0: Deleted }
                                                    { Bit 1: Unsent message }
                                             { Bit 2: Is a net mail message }
                                                           { Bit 3: Private }
                                                          { Bit 4: Received }
                                     { Bit 5: Unmoved Outgoing Echo Message }
                                                         { Bit 6: Local Bit }
                                                        { Bit 7: [Reserved] }
                   NetAttr    : Byte;                  { Netmail Attributes }
                                                         { Bit 0: Kill/sent }
                                                              { Bit 1: Sent }
                                                       { Bit 2: File attach }
                                                             { Bit 3: Crash }
                                                   { Bit 4: Request receipt }
                                                     { Bit 5: Audit request }
                                               { Bit 6: Is a return receipt }
                                                        { Bit 7: [Reserved] }
                   Board      : Byte;                         { Msg board # }
                   PostTime   : Time;            { Time when msg was posted }
                   PostDate   : Date;            { Date when msg was posted }
                   WhoTo      : MsgToIdxRecord;             { To who msg is }
                   WhoFrom    : MsgToIdxrecord;           { From who msg is }
                   Subject    : String[72];                   { Msg subject }
                 End;  { MsgHdrRecord }

  MsgTxtRecord = String[255];                                  { MSGTXT.BBS }

  USERONrecord   = record                                        { useron.bbs }
                     Name         : MsgToIdxRecord;            { Name of user }
                     Handle       : MsgToIdxRecord;          { Handle of user }
                     Line         : Byte;                  { Line/node number }
                     Baud         : Word;        { Baudrate user is logged on }
                     City         : String[25];           { City user is from }
                     Status       : Byte;              { 0=Browsing (in menu) }
                                                          { 1=Upload/Download }
                                                     { 2=Reading/Writing mail }
                                                                     { 3=Door }
                                                      { 4=Chatting with sysop }
                                                         { 5=In questionnaire }
                                                                      { 6=RTC }
                                                           { 7=New user logon }
                                        { 255=User-defined - display StatDesc }
                     Attribute    : Byte;                     { Bit 0: Hidden }
                                                         { Bit 1 : Wants chat }
                                              { Bit  2: Reserved for RANETMGR }
                                                { Bit  3: Do not disturb flag }
                                                     { Bit  6: Ready (0=busy) }

                     StatDesc       : String[10];     { What's the user doing }
                     FreeSpace      : Array[1..98] of Byte;
                     NoCalls        : Word;  { Number of calls from this user }
                   end; { UseronRecord }

  LastCallRecord = Record                                      { LASTCALL.BBS }
                     Line       : Byte;                         { Line number }
                     Name       : MsgToIdxRecord;              { Name of user }
                     Handle     : MsgToIdxRecord;            { Handle of user }
                     City       : String[25];             { City user is from }
                     Baud       : Word;            { Baud rate user logged on }
                     Times      : Longint;            { Times user has called }
                     LogOn      : Time;                          { LogOn time }
                     LogOff     : Time;                         { LogOff time }
                     Attribute  : Byte;                       { Bit 0: Hidden }
                   End;  { LastCallRecord }

  FILESHDRrecord = record                                    { HDR/FDB???.HDR }
                     Name           : String[12];              { Name of file }
                     Size,                                     { Size of file }
                     CRC32          : LongInt;                 { CRC of file? }
                     Uploader       : String[35];             { Uploader name }
                     UploadDate,                                { Upload date }
                     FileDate,                                    { File date }
                     LastDL         : LongInt;              { Last downloaded }
                     TimesDL        : Word;                { Times downloaded }
                     Attrib         : Byte;                 { Bit 0 : Deleted }
                                                           { Bit 1 : Unlisted }
                 { Bit 2 : Free (don't adjust ratio) - Does NOT affect "Cost" }
                              { Bit 3 : Not available (don't allow downloads) }
                                                   { Bit 4 : Locked (no kill) }
                                                    { Bit 5 : Missing/offline }
                             { Bit 6 : No time restrictions - always allow DL }
                     Password       : String[15];         { Download password }
                     KeyWord        : Array[1..5] of String[15];   { Keywords }
                     Cost           : Word;           { Cost to download file }
                     LongDescPtr    : LongInt;       { Pointer to description }
                     FreeSpace      : Array[1..20] of Byte;
                   end; { FilesHdrRecord }

  FILESIDXrecord = record                                    { IDX\FDB???.IDX }
                     Name           : String[12];                  { Filename }
                     UploadDate     : LongInt;                  { Upload date }
                     KeyWordCRC     : Array[1..5] of LongInt; { Keyword CRC's }
                     LongDescPtr    : LongInt;       { Pointer to description }
                   end; { FilesIdxRecord }

  USERSIDXrecord = record
                     NameCRC32,                             { CRC32 over name }
                     HandleCRC32    : LongInt;            { CRC32 over handle }
                   end;

  COMBINEDrecord = array[1..200] of Word;             { For combined messages }

  USERSrecord    = record                                         { Users.BBS }
                     Name           : MSGTOIDXrecord;             { User name }
                     Location       : String[25];               { User's city }
                     Organisation,                      { User's organisation }
                     Address1,                    { User's three line address }
                     Address2,
                     Address3       : String[50];
                     Handle         : String[35];             { User's handle }
                     Comment        : String[80];        { Comment about user }
                     PasswordCRC    : LongInt;          { CRC32 over password }
                     DataPhone,                         { User's data phone # }
                     VoicePhone     : String[15];      { User's voice phone # }
                     LastTime       : Time;        { Last time user logged on }
                     LastDate       : Date;        { Last date user logged on }

                     Attribute,                                  { Attributes }
                                                            { Bit 0 : Deleted }
                                                       { Bit 1 : Clear screen }
                                                        { Bit 2 : More prompt }
                                                               { Bit 3 : ANSI }
                                                            { Bit 4 : No-kill }
                                                      { Bit 5 : Xfer priority }
                                             { Bit 6 : Full screen msg editor }
                                                         { Bit 7 : Quiet mode }

                     Attribute2     : Byte;                      { Attributes }
                                                           { Bit 0 : Hot-keys }
                                                              { Bit 1 : AVT/0 }
                                         { Bit 2 : Full screen message viewer }
                                               { Bit 3 : Hidden from userlist }
                                                      { Bit 4 : Page priority }
                                        { Bit 5 : No echomail in mailbox scan }
                                                      { Bit 6 : Guest account }
                                                  { Bit 7 : Post bill enabled }

                     Flags          : FlagType;       { Flag settings of user }
                     Credit,                                { Netmail credits }
                     Pending      : LongInt;{ Credits in not yet send netmail }
                     MsgsPosted,                  { number of messages posted }
                     Security       : Word;           { User's security level }
                     LastRead,                    { Msg# of last read message }
                     NoCalls,                             { # Calls user made }
                     Uploads,                                  { # of uploads }
                     Downloads,                              { # of downloads }
                     UploadsK,                                { KB's uploaded }
                     DownloadsK,                            { KB's downloaded }
                     TodayK         : LongInt;        { Today downloaded KB's }
                     Elapsed        : Integer;        { Total time used today }
                     ScreenLength   : Word;            { User's screen length }
                     LastPwdChange  : Byte;{ # of calls since last pwd change }
                     Group          : Word;                    { User's group }
                     CombinedInfo   : COMBINEDrecord; { Combined reading info }
                     FirstDate,                        { Date of first log on }
                     BirthDate,                            { User's birthdate }
                     SubDate        : Date; { User's subscription expiry date }
                     ScreenWidth,                    { Width of user's screen }
                     Language,                            { User's language # }
                     DateFormat     : Byte;                     { Date format }
                     ForwardTo      : String[35];       { Forward msgs to ... }
                     MsgArea,                             { Last msgarea used }
                     FileArea       : Word;              { Last filearea used }
                     DefaultProtocol: Char;                { Default protocol }
                     FileGroup      : Word;             { Last filegroup used }
                     LastDOBCheck   : Byte; { # of calls since last DOB check }
                     Sex            : Byte;                      { User's sex }
                     XIrecord       : LongInt; { Pointer to record in USERSXI }
                     MsgGroup       : Word;         { Last message group used }
                     Attribute3     : byte;                      { attributes }
                            { bit 0 : Mailbox check: scan selected areas only }
                     Password       : String[15];                  { password }

                     FreeSpace      : Array[1..31] of Byte;
                   end; { UsersRecord }

  USERSXIrecord  = record                                       { UsersXI.BBS }
                     FreeSpace      : Array[1..200] of Byte;
                   end; { UsersXIRecord }

  SYSINFOrecord  = record                                       { Sysinfo.BBS }
                     TotalCalls  : LongInt;           { Total calls to system }
                     LastCaller  : MsgToIdxRecord;      { Name of last caller }
                     LastHandle     : MSGTOIDXrecord; { Handle of last caller }
                     ExtraSpace  : Array[1..92] of Byte;         { Future use }
                   end; { SysInfoRecord }

  TimeLogRecord  = Record                                      { TIMELOG.BBS }
                     StartDate   : Date;                     { Date of start }
                     BusyPerHour : Array[0..23] of Word;    { Mins used/hour }
                     BusyPerDay  : Array[0..6] of Word;       { Not used yet }
                   End;  { TimeLogRecord }

  MNUrecord      = record                                            { *.MNU }
                     Typ            : Byte;                    { Menu type # }
                     Security,                             { Security needed }
                     MaxSec         : Word;           { Max security allowed }
                     NotFlagsMask,            { You may not have these flags }
                     Flags          : FlagType;{You have to have these flags }
                     TimeLeft,                        { The time left needed }
                     TimeUsed       : Word;           { The time used needed }
                     Age,                               { Minimum age needed }
                     TermAttrib     : Byte;      { Terminal emulation needed }
                                                              { Bit 0 : ANSI }
                                                               { Bit 1 : AVT }
                                                               { Bit 2 : RIP }

                     MinSpeed,                        { Minimum speed needed }
                     MaxSpeed,                       { Maximum speed allowed }
                     Credit,                                 { Credit needed }
                     OptionCost,                            { Cost of option }
                     PerMinCost     : LongInt;   { Cost per minute of option }

                     Node,               { Nodes this option is available on }
                     Group          : ByteArray32;   { Groups this option is
                                                               available for }
                     StartTime,              { Time this option is available }
                     StopTime       : Array[1..7] of Word;
                     Display        : String[135];     { Displayed on screen }
                     HotKey         : String[8];    { Hotkey for this option }
                     MiscData       : String[135];              { Misc. data }
                     Foreground,                          { Foreground color }
                     Background     : Byte;               { Background color }
                     FreeSpace      : Array[1..50] of Byte;
                   end; { MNURecord }

  EventRecord    = Record                                        { EVENTS.RA }
                     Status      : Byte;                   { Status of event }
                                                                 { 0=Deleted }
                                                                 { 1=Enabled }
                                                                { 2=Disabled }
                     StartTime   : Time;               { Time to start event }
                     ErrorLevel  : Byte;                { Errorlevel to exit }
                     Days        : Byte;                 { Days to be active }
                     Forced      : Boolean;                    { Force event }
                     LastTimeRun : Date;                  { Date of last run }
                   End;  { EventRecord }


  EVENTrecordArray = array[1..20] of EVENTrecord;                { Events.RA }

  MESSAGErecord  = record                                      { Messages.RA }
                     Areanum,                                   { areanumber }
                     Unused         : word;
                     Name           : String[40];         { Name of MSG-Area }
                     Typ            : MsgType;               { Msg-Area type }
                     MsgKinds       : MsgKindsType;           { Kind of Msgs }
                     Attribute      : Byte;        { Bit 0 : Enable EchoInfo }
                                                   { Bit 1 : Combined access }
                                                     { Bit 2 : File attaches }
                                                     { Bit 3 : Allow aliases }
                                         { Bit 4 : Use SoftCRs as characters }
                                                      { Bit 5 : Force handle }
                                                     { Bit 6 : Allow deletes }
                                                     { Bit 7 : Is a JAM area }

                     DaysKill,                    { Kill older than 'x' days }
                     RecvKill       : Byte;  { Kill recv msgs after 'x' days }
                     CountKill      : Word;   { Maximum msgs allowed in area }

                     ReadSecurity   : Word;                   { Read security }
                     ReadFlags,                                  { Read flags }
                     ReadNotFlags   : FlagType;              { Read not flags }

                     WriteSecurity  : Word;                  { Write security }
                     WriteFlags,                                { Write flags }
                     WriteNotFlags  : FlagType;             { Write not flags }

                     SysopSecurity  : Word;                  { Sysop security }
                     SysopFlags,                                { Sysop flags }
                     SysopNotFlags  : FlagType;             { Sysop not flags }

                     OriginLine     : String[60];               { Origin line }
                     AkaAddress     : Byte;                      { Aka to use }

                     Age            : Byte;                      { Age needed }

                     JAMbase        : String[60];      { Directory of jamBase }
                     Group          : Word;                      { Main group }
                     AltGroup       : Array[1..3] of Word;{Alternitive groups }

                     Attribute2     : Byte;   { Bit 0 : Include in all groups }

                     NetReply       : Word;
                     FreeSpace2     : Array[1..7] of Byte;
                   end; { MESSAGErecord }

  GROUPrecord    = record                           { MGROUPS.RA / FGROUPS.RA }
                     AreaNum        : Word;                      { areanumber }
                     Name           : String[40];             { Name of group }
                     Security       : Word;                 { Security needed }
                     Flags,                                    { Flags needed }
                     NotFlagsMask   : FlagType;           { Flags not allowed }
                     FreeSpace      : Array[1..100] of Byte;
                   end; { GROUPrecord }

  FILESrecord    = record                                          { Files.RA }
                     Areanum,                                    { areanumber }
                     Unused         : word;
                     Name           : String[40];              { Name of area }
                     Attrib         : Byte;{Bit 0 : Include in new files scan }
                                        { Bit 1 : Include in upload dupe scan }
                                           { Bit 2 : Permit long descriptions }
                                                  { Bit 3 : Area is on CD-ROM }
                                                 { Bit 4 : All files are FREE }
                                               { Bit 5 : Allow DLs not in FDB }
                                    { Bit 6 : Allow users to password uploads }
                                                       { Bit 7 : Scan uploads }

                     FilePath       : String[40];         { DOS Path to files }
                     KillDaysDL,         { Days to keep since last downloaded }
                     KillDaysFD     : Word;      { Days to keep ( file date ) }
                     Password       : String[15];         { Password for area }
                     MoveArea       : Word;       { Move to area # (0=delete) }
                     Age,                                        { Age needed }
                     ConvertExt     : Byte;                      { convert to }
                     Group          : Word;                           { Group }
                     Attrib2        : Byte;   { Bit 0 : Include in all groups }

                     DefCost,                                         { costs }
                     UploadArea,                      { alternate upload area }
                     UploadSecurity : Word;                 { upload security }
                     UploadFlags,                              { upload flags }
                     UploadNotFlags : FlagType;            { upload not flags }
                     Security       : Word;               { download security }
                     Flags,                                  { download flags }
                     NotFlags       : FlagType;          { download not flags }
                     ListSecurity   : Word;                   { list security }
                     ListFlags,                                  { list flags }
                     ListNotFlags   : FlagType;              { list not flags }
                     AltGroup       : Array[1..3] of Word; { alternate groups }
                     Device         : Byte;                          { device }
                     FreeSpace      : Array[1..13] of Byte;        { reseverd }
                   end; { FILESrecord }

  CONFrecord     = record
                     Name,                               { name of conference }
                     Parent         : String[8];       { parant of conference }
                     Desc           : String[70];    { conference description }
                     Attr           : Byte;                 { Bit 0 : Private }
                                                               { 1 : Unlisted }
                                                                 { 2 : Global }
                                                              { 3 : Permanent }
                                                            { 4 : Use handles }
                     Moderator      : String[35];      { conference moderator }
                     Language       : String[20];    { Language of conference }
                     Password       : String[15];       { conference password }
                     Security       : Word;                        { security }
                     Flags          : FlagType;                       { flags }
                     NumNodes       : Byte;                       { max nodes }
                     Active         : Array[1..250] of Byte;   { nodes active }
                     Child          : Array[1..250] of Boolean;    { children }
                     NotFlagsMask   : FlagType;                   { not flags }
                     FreeSpace      : Array[1..96] of Byte;
                   end; { CONFrecord }

  MODEMrecord  = record                                            { modem.ra }
                   ComPort,                     { fields speak for themselves }
                   InitTries        : Byte;    { # of initialisation attempts }
                   BufferSize,                                  { buffer size }
                   ModemDelay       : Word;                     { modem delay }
                   MaxSpeed         : LongInt;           { max speed of modem }
                   SendBreak,                                   { send break? }
                   LockModem,                                 { locked speed? }
                   AnswerPhone,                              { manual answer? }
                   OffHook          : Boolean;   { modem offhook after caller }
                   InitStr,                                 { 1st init string }
                   InitStr2,                                { 2nd init string }
                   BusyStr          : String[70];{string to put modem off hook}
                   InitResp,                                    { OK response }
                   BusyResp,                                  { BUSY response }
                   Connect300,                      { various connect strings }
                   Connect1200,
                   Connect2400,
                   Connect4800,
                   Connect7200,
                   Connect9600,
                   Connect12k,
                   Connect14k,
                   Connect16k,
                   Connect19k,
                   Connect38k,
                   ConnectFax       : String[40];
                   RingStr,                                            { RING }
                   AnswerStr        : String[20];            { Answer command }
                   ErrorFreeString  : String[15];        { Error free connect }
                   Connect21k,
                   Connect24k,
                   Connect26k,
                   Connect28k,
                   Connect57k,
                   Connect64k,
                   Connect31k,
                   Connect33k       : String[40];

                   FreeSpace        : Array[1..100] of Byte;
                 end; { MODEMrecord }

  ARCrecord = record
                Extension : String[3];           { extension used by archiver }
                UnpackCmd,                                   { unpack command }
                PackCmd   : String[60];                        { pack command }
              end; { ARCrecord }

  CONFIGrecord = record
    VersionID           : Word;                                     { = $0202 }
    xCommPort           : Byte;         { fields starting with x are not used }
    xBaud               : LongInt;
    xInitTries          : Byte;
    xInitStr,
    xBusyStr            : String[70];
    xInitResp,
    xBusyResp,
    xConnect300,
    xConnect1200,
    xConnect2400,
    xConnect4800,
    xConnect9600,
    xConnect19k,
    xConnect38k         : String[40];
    xAnswerPhone        : Boolean;
    xRing,
    xAnswerStr          : String[20];
    xFlushBuffer        : Boolean;
    xModemDelay         : Integer;

    MinimumBaud,                                 { Minimum baudrate to log-on }
    GraphicsBaud,                                 { Minimum baudrate for Ansi }
    TransferBaud        : Word;              { Minimum baud for file transfer }
    SlowBaudTimeStart,                   { StartTime for 300bps file transfer }
    SlowBaudTimeEnd,                      { End Time for 300bps file transfer }
    DownloadTimeStart,                         { Start time for file transfer }
    DownloadTimeEnd     : Time;                  { End time for file transfer }

    PageStart           : Array[0..6] of Time;             { Page start times }
    PageEnd             : Array[0..6] of Time;              { Page stop times }

    SeriNum,                                                  { serial number }
    CustNum             : String[22];                       { customer number }
    FreeSpace1          : Array[1..24] of Byte;
    PwdExpiry           : Word;

    MenuPath,
    TextPath,
    AttachPath,
    NodelistPath,
    MsgBasePath,
    SysPath,
    ExternalEdCmd       : String[60];

    Address             : Array[0..9] of NetAddress;
    SystemName          : String[30];

    NewSecurity         : Word;
    NewCredit           : Word;
    NewFlags            : FlagType;

    OriginLine          : String[60];
    QuoteString         : String[15];
    Sysop               : String[35];
    LogFileName         : String[60];
    FastLogon,
    AllowSysRem,
    MonoMode,
    StrictPwdChecking,
    DirectWrite,
    SnowCheck           : Boolean;
    CreditFactor        : Integer;

    UserTimeOut,
    LogonTime,
    PasswordTries,
    MaxPage,
    PageLength          : Word;
    CheckForMultiLogon,
    ExcludeSysopFromList,
    OneWordNames        : Boolean;
    CheckMail           : AskType;
    AskVoicePhone,
    AskDataPhone,
    DoFullMailCheck,
    AllowFileShells,
    FixUploadDates,
    FreezeChat          : Boolean;
    ANSI,                       { ANSI: Yes, no, or ask new users     }
    ClearScreen,                { Clear:        "                     }
    MorePrompt          : AskType;    { More:         "                     }
    UploadMsgs          : Boolean;
    KillSent            : AskType;    { Kill/Sent     "                     }

    CrashAskSec         : Word;       { Min sec# to ask 'Crash Mail ?'      }
    CrashAskFlags       : FlagType;
    CrashSec            : Word;       { Min sec# to always send crash mail. }
    CrashFlags          : FlagType;
    FAttachSec          : Word;       {        "    ask 'File Attach ?'     }
    FAttachFlags        : FlagType;

    NormFore,
    NormBack,
    StatFore,
    StatBack,
    HiBack,
    HiFore,
    WindFore,
    WindBack,
    ExitLocal,
    Exit300,
    Exit1200,
    Exit2400,
    Exit4800,
    Exit9600,
    Exit19k,
    Exit38k             : Byte;

    MultiLine           : Boolean;
    MinPwdLen           : Byte;
    MinUpSpace          : Word;
    HotKeys             : AskType;
    BorderFore,
    BorderBack,
    BarFore,
    BarBack,
    LogStyle,
    MultiTasker,
    PwdBoard            : Byte;
    xBufferSize         : Word;
    FKeys               : Array[1..10] of String[60];

    WhyPage             : Boolean;
    LeaveMsg            : Byte;
    ShowMissingFiles,
    xLockModem          : Boolean;
{}  FreeSpace2          : Array[1..10] of Byte;
    AllowNetmailReplies : Boolean;
    LogonPrompt         : String[40];
    CheckNewFiles       : AskType;
    ReplyHeader         : String[60];
    BlankSecs           : byte;
    ProtocolAttrib      : Array[1..6] of Byte;
    xErrorFreeString    : String[15];
    xDefaultCombined    : array[1..25] of Byte;
    RenumThreshold      : Word;
    LeftBracket,
    RightBracket        : Char;
    AskForHandle        : Boolean;
    AskForBirthDate     : Boolean;

    GroupMailSec        : Word;

    ConfirmMsgDeletes   : Boolean;

    FreeSpace4          : Array[1..30] of byte;

    TempScanDir         : String[60];
    ScanNow             : AskType;
    xUnknownArcAction,
    xFailedUnpackAction,
    FailedScanAction    : Byte; {Bit 0:Mark deleted, 1:Mark unlisted, 2:Mark notavail}
    xUnknownArcArea,
    xFailedUnpackArea,
    FailedScanArea      : Word;
    ScanCmd             : String[60];
    xDeductIfUnknown    : Boolean;

    NewUserGroup        : Byte;
    AVATAR              : AskType;
    BadPwdArea          : Byte;
    Location            : String[40];
    DoAfterAction       : Byte; {0 = wait for CR, > 0 = wait for x seconds}
{}  OldFileLine         : String[40];
    CRfore,
    CRback              : Byte;
    LangHdr             : String[40];
    xSendBreak          : Boolean;
{}  ListPath            : String[60];
    FullMsgView         : AskType;
    EMSI_Enable         : AskType;
    EMSI_NewUser        : Boolean;

    EchoChar            : String[1];
    xConnect7200,
    xConnect12000,
    xConnect14400       : String[40];
    Exit7200,
    Exit12000,
    Exit14400           : Byte;
    ChatCommand         : String[60];
    ExtEd               : AskType;
    NewuserLanguage     : Byte;
    LanguagePrompt      : String[40];
    VideoMode           : VideoType;
    AutoDetectANSI      : Boolean;
    xOffHook            : Boolean;
    NewUserDateFormat   : Byte;
    KeyboardPwd         : String[15];
    CapLocation         : Boolean;
    NewuserSub          : Byte;
    PrinterName         : String[4];
    HilitePromptFore,
    HiLitePromptBack    : Byte;
    xInitStr2           : String[70];
    AltJSwap            : Boolean;
    SemPath             : String[60];
    AutoChatCapture     : Boolean;

    FileBasePath        : String[60];
    NewFileTag          : Boolean;
    IgnoreDupeExt       : Boolean;
    TempCDFilePath      : String[60];
    TagFore,
    TagBack             : Byte;
    xConnect16k         : String[40];
    Exit16k,
    FilePayback         : Byte;
    FileLine,
    FileMissingLine     : String[200];
    NewUserULCredit     : Byte;
    NewUserULCreditK    : Word;
    ArcInfo             : Array[1..10] of ARCrecord;
    RAMGRAltFKeys       : Array[1..5] of String[60];
    ArcViewCmd          : String[60];
    xConnectFax         : String[40];
    ExitFax             : Byte;
    UseXMS,
    UseEMS              : Boolean;
    CheckDOB            : Byte;
    EchoCheck           : AskType;
    ccSec,
    ReturnRecSec        : Word;
    HonourNetReq        : Boolean;
    DefaultCombined     : COMBINEDrecord;
    AskForSex,
    AskForAddress       : Boolean;
    DLdesc              : AskType;
    NewPhoneScan        : Boolean;
    Exit21k,
    Exit24k,
    Exit26k,
    Exit28k,
    Exit57k,
    Exit64k             : Byte;
    TagLogoffWarning,
    LimitLocal,
    SavePasswords       : Boolean;

    BlankLogins         : Byte;
    ripiconpath         : string[60];

    Exit31k,
    Exit33k             : Byte;
    IncludeNewCDareas   : Boolean;

    FutureExpansion : Array[1..513] of Byte;
  end;

  EXITINFOrecord = record
                     Baud             : Word;
                     SysInfo          : SYSINFOrecord;
                     TimeLogInfo      : TIMELOGrecord;
                     UserInfo         : USERSrecord;
                     EventInfo        : EVENTrecord;
                     NetMailEntered,
                     EchoMailEntered  : Boolean;
                     LoginTime        : Time;
                     LoginDate        : Date;
                     TimeLimit        : Word;
                     LoginSec         : LongInt;
                     UserRecord       : Integer;
                     ReadThru,
                     NumberPages,
                     DownloadLimit    : Word;
                     TimeOfCreation   : Time;
                     LogonPasswordCRC : LongInt;
                     WantChat         : Boolean;

                     DeductedTime     : Integer;
                     MenuStack        : Array[1..50] of String[8];
                     MenuStackPointer : Byte;
                     UserXIinfo       : USERSXIrecord;
                     ErrorFreeConnect,
                     SysopNext        : Boolean;

                     EMSI_Session     : Boolean;        { These fields hold  }
                     EMSI_Crtdef,                       { data related to an }
                     EMSI_Protocols,                    { EMSI session       }
                     EMSI_Capabilities,
                     EMSI_Requests,
                     EMSI_Software    : String[40];
                     Hold_Attr1,
                     Hold_Attr2,
                     Hold_Len         : Byte;

                     PageReason       : String[80];
                     StatusLine       : Byte;
                     LastCostMenu     : String[8];
                     MenuCostPerMin   : Word;
                     DoesAVT,
                     RIPmode          : Boolean;
                     RIPVersion       : Byte;
                     ExtraSpace       : Array[1..85] of Byte;
                 end;

  PROTOCOLrecord = record
                     Name           : String[15];
                     ActiveKey      : Char;
                     OpusTypeCtlFile,
                     BatchAvailable : Boolean;
                     Attribute      : Byte; { 0=Disabled, 1=Enabled }
                     LogFileName,
                     CtlFileName,
                     DnCmdString,
                     DnCtlString,
                     UpCmdString,
                     UpCtlString    : String[80];
                     UpLogKeyword,
                     DnLogKeyword   : String[20];
                     XferDescWordNum,
                     XferNameWordNum : Byte;
                   end;

  ProtocolFile = File of ProtocolRecord;                      { PROTOCOL.RA }
  SysInfoFile  = File of SysInfoRecord;                       { SYSINFO.BBS }
  TimeLogFile  = File of TimeLogRecord;                       { TIMELOG.BBS }
  UserOnFile   = File of UserOnRecord;                         { USERON.BBS }
  LastCallFile = File of LastCallRecord;                     { LASTCALL.BBS }
  ExitInfoFile = File of ExitInfoRecord;                     { EXITINFO.BBS }
  UsersFile    = File of UsersRecord;                           { USERS.BBS }
  UsersXIFile  = File of UsersXiRecord;                       { USERSXI.BBS }
  LastReadFile = File of LastReadRecord;                     { LASTREAD.BBS }
  CombinedFile = File of CombinedRecord;                     { COMBINED.BBS }
  ConfigFile   = File of ConfigRecord;                          { CONFIG.RA }
  FilesFile    = File of FilesRecord;                            { FILES.RA }
  MessageFile  = File of MessageRecord;                       { MESSAGES.RA }
  EventFile    = File of EventRecordArray;                      { EVENTS.RA }
  LanguageFile = File of LanguageRecord;                      { LANGUAGE.RA }
  UsersIdxFile = File of UsersIdxRecord;                     { USERSIDX.BBS }
  NodeIdxFile  = File of NodeIdxRecord;                        { NODEIDX.RA }
  NodeIncFile  = File of NodeIncRecord;                        { NODEINC.RA }

  Msgfiles     = Record
                   Info     : File of MsgInfoRecord;          { MSGINFO.BBS }
                   Idx      : File of MsgIdxRecord;            { MSGIDX.BBS }
                   Hhr      : File of MsgHdrRecord;            { MSGHDR.BBS }
                   ToIdx    : File of MsgToIdxRecord;        { MSGTOIDX.BBS }
                   Txt      : File of MsgTxtRecord;            { MSGTXT.BBS }
                   MsgInfo  : MsgInfoRecord;                 { Message info }
                 End;  { MsgFiles }

{
                 Pfjew, why didn't Andrew make such a struct?
}

implementation

end.
